<?php
error_reporting(E_ALL);
include_once( dirname( __FILE__ ) . '/include/yd2/YDF2_init.php' );

YDInclude( 'YDDatabase.php' );
YDInclude( 'YDDatabaseMetaData.php' );
YDInclude( 'YDDatabaseObject.php' );
YDInclude( 'YDFileSystem.php' );
YDInclude( 'YDUtil.php' );

// Check if a directory is writeable
function checkWriteableDirectory( $dir ) {
	if ( ! is_writeable( $dir ) ) {
		showError('Make sure the directory ' . realpath( $dir ) . ' is writeable before installing.' );
	}
}

 function saveConfig(  ) {
		$values = array();
        // Add some default ones

        $values['dir_skins'] = 'skins';
        $values['dir_media'] = 'media';
        $values['app_skin'] = 'default';
        $values['app_language'] = 'en';
        $values['use_cache'] = '';
        $values['include_debug_info'] = 0;
        $values['YD_PERSISTENT_STORE_NAME'] = 'webblocks';
        $values['defaultGroup'] = 'Main';
        $values['defaultPage'] = 'HomePage';
        $values['SiteGroup'] = 'Site';

        $values['db_host'] = $_POST['db_host'];
        $values['db_name'] = $_POST['db_name'];
        $values['db_user'] = $_POST['db_user'];
        $values['db_pass'] = $_POST['db_password'];

        $values['db_prefix'] = 'wb_';

                // Construct the new config text
        $cfg = '<?php' . "\n\n";
        $cfg .= '    // WebBlocks Configuration ' . "\n";
 		$cfg .= 'if ( ! defined( \'WebBlocks\' ) ) { '. "\n";
	    $cfg .= '    die( \'Not loaded.\' );'. "\n";
    	$cfg .= '}'. "\n";
        // Loop over the config values
        foreach ( $values as $key=>$val ) {

            // Ignore items starting with an underscore
            if ( substr( $key, 0, 1 ) != '_' ) {

                // Escape strings
                $key = str_replace( "'", "\\'", $key );
                $val = str_replace( "'", "\\'", $val );

                // Don't enclose numeric values with quotes
                if ( is_bool( $val ) ) {
                    $val = ( $val ) ? 'true' : 'false';
                    $cfg .= "    YDConfig::set( '" . $key . "', " . $val . " );\n";
                } elseif ( is_numeric( $val ) ) {
                    $cfg .= "    YDConfig::set( '" . $key . "', " . $val . " );\n";
                } else {
                    $cfg .= "    YDConfig::set( '" . $key . "', '" . $val . "' );\n";
                }
            }
        }
        $cfg .= "\n" . '?>';

        // Open the config file
        $f = fopen( dirname( __FILE__ ) . '/include/config.php', 'w' );
        fwrite( $f, $cfg );
        fclose( $f );

 }

function getConnection() {

	if (isset($_POST['db_name'])) {
		$db_name = $_POST['db_name'];
	}
	if (isset($_POST['db_user'])) {
		$db_user = $_POST['db_user'];
	}
	if (isset($_POST['db_password'])) {
		$db_password = $_POST['db_password'];
	}
	if (isset($_POST['db_host'])) {
		$db_host = $_POST['db_host'];
	}
	$db = YDDatabase::getInstance('mysql',$db_name, $db_user, $db_password, $db_host );
	if(!$db) {
		showError('Failed to connect to database.');
	}
	return $db;
}

function runSQLScript( $separator=";" ) {
	$content = getScriptFileContent();
	// delete sql comments
	$content = preg_replace('/(--)(.*)(\n)/e', "", $content);

	// get array of queries
	$content = explode( $separator, $content );

	// delete last element (is always null)
	array_pop( $content );

	$db = getConnection();
	// execute each sql element of array
	foreach ( $content as $sql_query ) {
		if($db)
		$db->executeSql( trim( $sql_query ) );
	}

	if (isset($_POST['user_name'])) {
		$user_name = $_POST['user_name'];
	}
	if (isset($_POST['user_email'])) {
		$user_email = $_POST['user_email'];
	}
	if (isset($_POST['user_password1'])) {
		$user_password = md5($_POST['user_password1']);
	}
	$sql = "insert into wb_users values (null,'".$user_name."','".$user_email."','".$user_password."','admin',unix_timestamp(),unix_timestamp(),0)";
	$db->executeSql( trim( $sql ) );


}

function getScriptFileContent() {
	$file = new YDFSFile( dirname( __FILE__ ). '/webblocks-setup.sql');
	return $file->getContents();

}

function showError($err) {
	echo( '<html><head><title>WebBlocks Installer</title></head><body>' );
	echo( '<p><font color="red"><b>'.$err.'</b></font></p>' );
	echo('</body></html>');
	die();
}
// start installer
checkWriteableDirectory(dirname( __FILE__ ) . '/include');

if(is_file( dirname( __FILE__ ) . '/include/config.php' ) ) {
	showError('WebBlocks already installed.');
}

if (isset($_POST['db_name'])) {
	runSQLScript();
	saveConfig();
	?>
<html>
<head>
<title>WebBlocks Installer</title>
</head>
<body>
WebBlocks installed successfully.
<a href="index.php">Click here </a> for homepage.
</body>
</html>

	<?php
}

else {

	?>
<html>
<head>
<title>WebBlocks Installer</title>
<script type="text/javascript">
 function checkForm(form)
 {

 	if(form.db_host.value == "")	{
 	 alert("Error: Database host cannot be blank!");
  	 form.db_host.focus();
     return;
   }
   if(form.db_name.value == "")	{
 	 alert("Error: Database name cannot be blank!");
  	 form.db_name.focus();
     return;
   }

 	if(form.user_email.value == "")	{
 	 alert("Error: User email cannot be blank!");
  	 form.user_email.focus();
     return;
   }
   if(form.user_password1.value == "")	{
 	 alert("Error: User password cannot be blank!");
  	 form.user_password1.focus();
     return;
   }
   if(form.user_password1.value != form.user_password2.value) {
   	  alert("Error: User password does not match!");
  	 form.user_password1.focus();
  	 return;
   }
   form.submit();
}
 </script>


</head>
<body>
<h2>Install WebBlocks</h2>
<h3>Database Settings</h3>
<form method=post>
<p>Database host : <input type=text name=db_host>
<p>Database name : <input type=text name=db_name>. Database must exists before installation.
<p>Database user : <input type=text name=db_user>
<p>Database password : <input type=password name=db_password>

<h3>Create Administrator user</h3>
<p>User name : <input type=text name=user_name>
<p>User email: <input type=text name=user_email> . Email is used for login into WebBlocks.
<p>User password : <input type=password name=user_password1>
<p>User password again : <input type=password name=user_password2>


<p>


<p><input type=Button onClick="checkForm(document.forms[0]);" value="Install WebBlocks">

</form>
</body>
</html>
	<?php
}

?>
