-- Database: for WebBlocks
-- Table prefix is wb. It can be changed.

-- --------------------------------------------------------

-- 
-- Table structure for table 'wb_actionlog'
-- 

CREATE TABLE wb_actionlog (
  log_id int(11) NOT NULL auto_increment,
  log_msg varchar(255) default NULL,
  created int(11) default NULL,
  log_category varchar(50) default NULL,
  http_referer varchar(255) default NULL,
  remote_address varchar(32) default NULL,
  user_agent varchar(255) default NULL,
  PRIMARY KEY  (log_id)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;


-- 
-- Table structure for table 'wb_config'
-- 

CREATE TABLE wb_config (
  parameter varchar(255) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (parameter,`value`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

-- 
-- Table structure for table 'wb_pagehistory'
-- 

CREATE TABLE wb_pagehistory (
  page_id int(11) NOT NULL default '0',
  author_id int(11) default NULL,
  modified int(11) NOT NULL default '0',
  diff longtext,
  remote_address varchar(128) default NULL,
  PRIMARY KEY  (modified,page_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

-- 
-- Table structure for table 'wb_pagepermission'
-- 

CREATE TABLE wb_pagepermission (
  id tinyint(4) NOT NULL auto_increment,
  pagename varchar(255) default NULL,
  pagegroup varchar(255) default NULL,
  aro varchar(50) NOT NULL default '',
  aco_code smallint(4) NOT NULL default '0',
  PRIMARY KEY  (id)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

-- 
-- Table structure for table 'wb_pages'
-- 

CREATE TABLE wb_pages (
  page_id int(11) NOT NULL auto_increment,
  name varchar(255) default NULL,
  pagegroup varchar(255) default NULL,
  pagetext longtext NOT NULL,
  created int(11) default NULL,
  textformat enum('smarty','html','bbcode') NOT NULL default 'smarty',
  modified int(11) default NULL,
  pagedesc varchar(255) default NULL,
  pagekeywords varchar(255) default NULL,
  deleted tinyint(4) default '0',
  searchable tinyint(4) default '1',
  publish_date int(11) default NULL,
  is_draft tinyint(4) NOT NULL default '0',
  is_standalone tinyint(4) default '0',
  PRIMARY KEY  (page_id),
  UNIQUE KEY name_group (name,pagegroup)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

-- 
-- Table structure for table 'wb_permissions'
-- 

CREATE TABLE wb_permissions (
  permission_name varchar(50) NOT NULL default '',
  permission_desc varchar(255) default NULL,
  aco_code smallint(4) default NULL,
  PRIMARY KEY  (permission_name)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

-- 
-- Table structure for table 'wb_usergroups'
-- 

CREATE TABLE wb_usergroups (
  usergroup_name varchar(50) NOT NULL default '',
  usergroup_desc varchar(255) default NULL,
  deleted tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (usergroup_name)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

-- 
-- Table structure for table 'wb_users'
-- 

CREATE TABLE wb_users (
  user_id int(11) NOT NULL auto_increment,
  name varchar(255) default NULL,
  email varchar(255) NOT NULL default '',
  `password` varchar(50) default NULL,
  usergroup_name varchar(50) NOT NULL default 'registered',
  created int(11) default NULL,
  modified int(11) default NULL,
  deleted tinyint(4) default '0',
  PRIMARY KEY  (user_id)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;





-- Config data

INSERT INTO `wb_config` VALUES ('app_skin', 'default');
INSERT INTO `wb_config` VALUES ('defaultGroup', 'Main');
INSERT INTO `wb_config` VALUES ('defaultPage', 'HomePage');
INSERT INTO `wb_config` VALUES ('SiteGroup', 'Site');

-- Page permissions

INSERT INTO `wb_usergroups` VALUES ('admin', 'Administrator group', 0);
INSERT INTO `wb_usergroups` VALUES ('registered', 'registered users', 0);
INSERT INTO `wb_usergroups` VALUES ('unregistered', 'unregistered users', 0);


INSERT INTO `wb_permissions` VALUES ('none', 'none', -1);
INSERT INTO `wb_permissions` VALUES ('createpage', 'create page', 1);
INSERT INTO `wb_permissions` VALUES ('readpage', 'read page', 2);
INSERT INTO `wb_permissions` VALUES ('editpage', 'edit page', 4);
INSERT INTO `wb_permissions` VALUES ('deletepage', 'delete page', 8);
INSERT INTO `wb_permissions` VALUES ('attrpage', 'attribute page', 16);
INSERT INTO `wb_permissions` VALUES ('includepage', 'include page', 32);




INSERT INTO `wb_pagepermission` VALUES (null, NULL, NULL, 'admin', 1023);
INSERT INTO `wb_pagepermission` VALUES (null, NULL, NULL, 'unregistered', 2);
INSERT INTO `wb_pagepermission` VALUES (null, NULL, NULL, 'registered', 15);
INSERT INTO `wb_pagepermission` VALUES (null, NULL, 'Admin', 'unregistered', -1);
INSERT INTO `wb_pagepermission` VALUES (null, NULL, 'Admin', 'registered', -1);
INSERT INTO `wb_pagepermission` VALUES (null, 'HomePage', 'Site', 'unregistered', -1);



-- Default group Main

INSERT INTO wb_pages VALUES (null, 'HomePage', 'Main', 'This is default homepage.', unix_timestamp(), 'smarty', unix_timestamp(), 'Main', 'WebBlocks', 0, 1, unix_timestamp(), 0, 0);

-- Site Group pages

INSERT INTO wb_pages VALUES (null, 'HomePage', 'Site', 'Site group has pages which are used for WebBlocks configuration.<br/>\r\n{listpages group=$groupname var="mypages"}\r\n<ul>\r\n{foreach from=$mypages item=mypage}\r\n    <li> <a href=''{$mypage.name|linkpage}''>{$mypage.name}</a> </li>\r\n{/foreach}\r\n</ul>', unix_timestamp(), 'smarty', unix_timestamp(), 'Site', 'WebBlocks', 0, 1, unix_timestamp(), 0, 0);

INSERT INTO wb_pages VALUES (null, 'RecentChanges', 'Site', '{if $wb_user}\r\n{listpages var="mypages" order="modified desc" limit="25"}\r\n{else}\r\n{listpages var="mypages" excludegroup="Site,Admin" order="modified desc" limit="25"}\r\n{/if}\r\n\r\n\r\n<center><h3>Recently updated pages</h3></center>\r\n<table align="center" width="75%" class="wb_table">\r\n<tr><th>Group</th><th>Page Name</th><th>Description</th>\r\n<th>Modified Date</th>\r\n</tr>\r\n{foreach from=$mypages item=mypage}\r\n   <tr >\r\n<td class="tddata">{$mypage.pagegroup}</td>\r\n<td class="tddata">\r\n  <a href=''{"`$mypage.pagegroup`.`$mypage.name`"|linkpage}''>\r\n  {$mypage.name}</a></td>\r\n  <td class="tddata">{$mypage.pagedesc}</td>\r\n  <td class="tddata">{$mypage.modified|date_format:''%Y-%m-%d %T''}</td>\r\n</tr>\r\n{/foreach}\r\n</table>', unix_timestamp(), 'smarty', unix_timestamp(), 'Recently updated pages', 'webblocks', 0, 1, unix_timestamp(), 0, 0);

INSERT INTO wb_pages VALUES (null, 'SearchResult', 'Site', '<center><h3>Search Result</h3></center>\r\n<table align="center" width="75%" class="wb_table">\r\n<tr><th>Group</th><th>Page Name</th><th>Description</th>\r\n<th>Modified Date</li>\r\n</tr>\r\n{foreach from=$wb_search item=mypage}\r\n   <tr >\r\n<td class="tddata">{$mypage.pagegroup}</td>\r\n<td class="tddata">\r\n  <a href=''{"`$mypage.pagegroup`.`$mypage.name`"|linkpage}''>\r\n  {$mypage.name}</a></td>\r\n  <td class="tddata">{$mypage.pagedesc}</td>\r\n  <td class="tddata">{$mypage.modified|date_format:''%Y-%m-%d %T''}</td>\r\n</tr>\r\n{/foreach}\r\n</table>', unix_timestamp(), 'smarty', unix_timestamp(), '', '', 0, 0, unix_timestamp(), 0, 0);

-- Admin Group page

INSERT INTO `wb_pages` VALUES (null, 'HomePage', 'Admin', '<h2>Admin group</h2>\r\n This is admin''s homepage.', unix_timestamp(), 'smarty', unix_timestamp(), '', '', 0, 0, unix_timestamp(), 0, 0);






